/**
 * @author     Sebastian Koschmieder <sep@seplog.org>
 * @date       2021-01-21 16:29:18
 */

#include <avr/io.h>
#include <stdint.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _UCTEST_UCTEST_DEVICE_AVR_H_
#if !defined( __DOXYGEN__ )
#define _UCTEST_UCTEST_DEVICE_AVR_H_
#endif

typedef uint8_t stack_t;

inline __attribute__( ( always_inline ) ) void uctest_stack_pushPtr( void *ptr ) {
    asm volatile( "push %B[ptr] \t\n"
                  "push %A[ptr] \t\n"
                  :
                  : [ptr] "r"( ptr )
                  : "memory" );
}

inline stack_t *uctest_getStackPtr( void ) {
    return ( stack_t * ) SP;
}

inline void uctest_setStackPtr( stack_t *ptr ) {
    SP = ( uint16_t ) ptr;
}

#define uctest_register_prototype( name ) \
    void __attribute__( ( naked, section( ".init5" ) ) ) name( void )

#endif /** _UCTEST_UCTEST_DEVICE_AVR_H_ */

#ifdef __cplusplus
}
#endif
